// mpichler, 19950801
#ifdef PMAX
enum Part { goofyPart };        // confused about QvCone::Part and QvCylinder::Part
enum Binding { goofyBinding };  // confused about QvMaterialBinding/QvNormalBinding::Binding
#endif

// mpichler, 19950802
#if defined(PMAX) || defined(PMAX_GNU)
#  include <string.h>
#  include <malloc.h>
char* strdup (const char* s)  // strdup not contained in system libraries
{
  char* p = (char*) malloc (strlen (s) + 1);
  if (p)
    strcpy (p, s);
  return p;
}
#endif

// changed by Gerbert Orasche 260695
#ifdef __PC__
#pragma warning(disable:4244)
#endif

// mpichler, 19951109
// definition of a suffix would be sufficient for compilers,
// but UNIX' makedepend does not check this

#ifdef __PC__

# define CPPSUFFIX ".cpp"

# include "QvAsciiText" CPPSUFFIX
# include "QvChildList" CPPSUFFIX
# include "QvCone" CPPSUFFIX
# include "QvCoordinate3" CPPSUFFIX
# include "QvCube" CPPSUFFIX
# include "QvCylinder" CPPSUFFIX
# include "QvDB" CPPSUFFIX
# include "QvDebugError" CPPSUFFIX
# include "QvDict" CPPSUFFIX
# include "QvDirectionalLight" CPPSUFFIX
# include "QvElement" CPPSUFFIX
# include "QvField" CPPSUFFIX
# include "QvFieldData" CPPSUFFIX
# include "QvFontStyle" CPPSUFFIX
# include "QvGroup" CPPSUFFIX
# include "QvIndexedFaceSet" CPPSUFFIX
# include "QvIndexedLineSet" CPPSUFFIX
# include "QvInfo" CPPSUFFIX
# include "QvInput" CPPSUFFIX
# include "QvLists" CPPSUFFIX
# include "QvLOD" CPPSUFFIX
# include "QvMFColor" CPPSUFFIX
# include "QvMFFloat" CPPSUFFIX
# include "QvMFLong" CPPSUFFIX
# include "QvMFString" CPPSUFFIX
# include "QvMFVec2f" CPPSUFFIX
# include "QvMFVec3f" CPPSUFFIX
# include "QvMaterial" CPPSUFFIX
# include "QvMaterialBinding" CPPSUFFIX
# include "QvMatrixTransform" CPPSUFFIX
# include "QvName" CPPSUFFIX
# include "QvNode" CPPSUFFIX
# include "QvNormal" CPPSUFFIX
# include "QvNormalBinding" CPPSUFFIX
# include "QvOrthographicCamera" CPPSUFFIX
# include "QvPList" CPPSUFFIX
# include "QvPerspectiveCamera" CPPSUFFIX
# include "QvPointLight" CPPSUFFIX
# include "QvPointSet" CPPSUFFIX
# include "QvReadError" CPPSUFFIX
# include "QvRotation" CPPSUFFIX
# include "QvSFBitMask" CPPSUFFIX
# include "QvSFBool" CPPSUFFIX
# include "QvSFColor" CPPSUFFIX
# include "QvSFEnum" CPPSUFFIX
# include "QvSFFloat" CPPSUFFIX
# include "QvSFImage" CPPSUFFIX
# include "QvSFLong" CPPSUFFIX
# include "QvSFMatrix" CPPSUFFIX
# include "QvSFRotation" CPPSUFFIX
# include "QvSFString" CPPSUFFIX
# include "QvSFVec2f" CPPSUFFIX
# include "QvSFVec3f" CPPSUFFIX
# include "QvScale" CPPSUFFIX
# include "QvSeparator" CPPSUFFIX
# include "QvShapeHints" CPPSUFFIX
# include "QvSphere" CPPSUFFIX
# include "QvSpotLight" CPPSUFFIX
# include "QvState" CPPSUFFIX
# include "QvString" CPPSUFFIX
# include "QvSwitch" CPPSUFFIX
# include "QvTexture2" CPPSUFFIX
# include "QvTexture2Transform" CPPSUFFIX
# include "QvTextureCoordinate2" CPPSUFFIX
# include "QvTransform" CPPSUFFIX
# include "QvTransformSeparator" CPPSUFFIX
# include "QvTranslation" CPPSUFFIX
# include "QvUnknownNode" CPPSUFFIX
# include "QvWWWAnchor" CPPSUFFIX
# include "QvWWWInline" CPPSUFFIX
  
# ifdef VRMLEXTENSIONS
#  include "QvExtensions" CPPSUFFIX
# endif

#else

/* #define CPPSUFFIX ".C" */

# include "QvAsciiText.C"
# include "QvChildList.C"
# include "QvCone.C"
# include "QvCoordinate3.C"
# include "QvCube.C"
# include "QvCylinder.C"
# include "QvDB.C"
# include "QvDebugError.C"
# include "QvDict.C"
# include "QvDirectionalLight.C"
# include "QvElement.C"
# include "QvField.C"
# include "QvFieldData.C"
# include "QvFontStyle.C"
# include "QvGroup.C"
# include "QvIndexedFaceSet.C"
# include "QvIndexedLineSet.C"
# include "QvInfo.C"
# include "QvInput.C"
# include "QvLists.C"
# include "QvLOD.C"
# include "QvMFColor.C"
# include "QvMFFloat.C"
# include "QvMFLong.C"
# include "QvMFString.C"
# include "QvMFVec2f.C"
# include "QvMFVec3f.C"
# include "QvMaterial.C"
# include "QvMaterialBinding.C"
# include "QvMatrixTransform.C"
# include "QvName.C"
# include "QvNode.C"
# include "QvNormal.C"
# include "QvNormalBinding.C"
# include "QvOrthographicCamera.C"
# include "QvPList.C"
# include "QvPerspectiveCamera.C"
# include "QvPointLight.C"
# include "QvPointSet.C"
# include "QvReadError.C"
# include "QvRotation.C"
# include "QvSFBitMask.C"
# include "QvSFBool.C"
# include "QvSFColor.C"
# include "QvSFEnum.C"
# include "QvSFFloat.C"
# include "QvSFImage.C"
# include "QvSFLong.C"
# include "QvSFMatrix.C"
# include "QvSFRotation.C"
# include "QvSFString.C"
# include "QvSFVec2f.C"
# include "QvSFVec3f.C"
# include "QvScale.C"
# include "QvSeparator.C"
# include "QvShapeHints.C"
# include "QvSphere.C"
# include "QvSpotLight.C"
# include "QvState.C"
# include "QvString.C"
# include "QvSwitch.C"
# include "QvTexture2.C"
# include "QvTexture2Transform.C"
# include "QvTextureCoordinate2.C"
# include "QvTransform.C"
# include "QvTransformSeparator.C"
# include "QvTranslation.C"
# include "QvUnknownNode.C"
# include "QvWWWAnchor.C"
# include "QvWWWInline.C"
  
# ifdef VRMLEXTENSIONS
#  include "QvExtensions.C"
# endif

#endif
